/* Baduki - Computer Baduk(Go) Program 
   Copyright(c) 1998-1999 Lim Jaebum <artist@soback.kornet21.net>

   This program is free software; you can redistribute it and'or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
   USA */

/* $Id: utils.h,v 1.10 1999/04/01 20:24:58 artist Exp artist $ */

#define iNil 32767		/* a distinguished value like nil */
#define  maxString 512
#define  maxSPoint 16
#define Default_tryLimit 50
#define MAX_STRING_PER_GROUP	20
#define MAX_GROUP	100

typedef int intBoard[19][19];	/* these were -2 to maxPoint + 2 */

typedef int boolBoard[19][19];

typedef struct {
  int px, py;
} point;

typedef struct {
  int px, py, color;
} pointc;

typedef struct {
  point p[401];
  int indx;
} pointList;

typedef struct {
  point p[maxSPoint + 1];
  int indx;
} sPointList;

typedef struct {
  int indx, v[401];
} intList;

typedef struct {
  int w, s, sm;
} sgRec;

typedef struct {
  int mark, score, eyes, min_x, max_x, min_y, max_y, lx, ly;
} vsgRec;

typedef struct {
  int stringMark, atLevel, gid,
  	isLive, isDead, isSafe, libC, numEyes, exts, size,
  	lx, ly, kx, ky, sx, sy, kc, sc;
} stringRec;

typedef struct {
  int Mark, strength, tr1, tr2, score, eyes, exts,
  	stones, strings, string[MAX_STRING_PER_GROUP];
} groupRec;

typedef enum {
  rem, add, chLib, reMap
} playType;

typedef struct {
  int who, xl, yl, nextSID, sNumber, lx, ly, pae;
} pAddRec;
typedef struct {
  int who, xl, yl, nextSID, sNumber;
} pRemRec;
typedef struct {
  int oldLC, oldLevel;
} chLibRec;
typedef struct {
  int oldSID;
} reMapRec;
typedef struct {
  int SID;
  playType kind;
  union {
    pRemRec rem;
    pAddRec add;
    chLibRec chLib;
    reMapRec reMap;
  } uval;
} playRec;

struct altmovestype {
  int px;
  int py;
  float value;
  int value2;
  int target;
  int why;
};
